/* Decompresses an image that has been compressed with horizontal RLE
 *
 * Paramenters:
 *   src = array of compressed data (pointer)
 *   dest = will become uncompressed array (pointer)
 *   size = size of decompressed data array
 *  src and dest need to be allocated before calling
 *  size needs to be initialized before calling
 */
#define SENTINEL_VALUE 0x91

void DecompRLEHor(unsigned char *src, unsigned char *dest, int size)
{
	int i = 0,j;
	int pos = 0;
	int dcmpNum = 0;

	while (dcmpNum < size)
	{
		//decompress a run
		if (src[i] == SENTINEL_VALUE)
		{
			i++;
			for(j = 0; j < src[i + 1]; j++)
				dest[pos++] = src[i];
			i++;
			dcmpNum += src[i];
		}
		else
		{
			dest[pos++] = src[i];
			dcmpNum++;			
		}
		i++;
	}
}
